`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company:				jc-21.ac Japan
// Engineer:			Takeshi Sakato
// 
// Create Date:		23:57:08 12/15/2012 
// Design Name:		Count_Renge
// Module Name:		Count_Renge
// Project Name:		RangFinderForRs232
// Target Devices:	Xilinx Spartan3E
// Tool versions:		ISE 8.2i
// Description: 
// (Lq)
//
// Dependencies: 
// (ˑ)
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Count_Renge(check_counter, RST, DATA_IN_EN, PLS_1mm, renge_dec, renge_bin);
	input [20:0]check_counter;
	input RST;
	input DATA_IN_EN;
	input PLS_1mm;
	output [15:0]renge_dec;
	output [15:0]renge_bin;
	
	reg [15:0]data_count_Bin = 16'h0000;	// Range data counter(binary)
	reg [15:0]data_count_Dec = 16'h0000;	// Range data counter(decimal)
	
	assign renge_dec = data_count_Dec;
	assign renge_bin = data_count_Bin;

////////// Count_Renge	gvvpXJE^
	always @(posedge PLS_1mm)
	begin
		// Count Enable //
		if(check_counter > 8000) begin

			// Count Start //
			if(DATA_IN_EN == 1'b1) begin
				data_count_Bin <= data_count_Bin + 1;

				// column-1 //
				if(data_count_Dec[3:0] == 4'h9) begin
					data_count_Dec[3:0] <= 4'h0;
					data_count_Dec[7:4] <= data_count_Dec[7:4] + 4'h1;

					// column-2 //
					if(data_count_Dec[7:4] == 4'h9) begin
						data_count_Dec[7:4] <= 4'h0;
						data_count_Dec[11:8] <= data_count_Dec[11:8] + 4'h1;

						// column-3 //
						if(data_count_Dec[11:8] == 4'h9) begin
							data_count_Dec[11:8] <= 4'h0;
							data_count_Dec[15:12] <= data_count_Dec[15:12] + 4'h1;

							// column-4 //
							if(data_count_Dec[15:12] == 4'h9) begin
								data_count_Dec[15:12] <= 4'h0;
							end
							else begin
								data_count_Dec[15:12] <= data_count_Dec[15:12] + 4'h1;
							end
							//4-4-4-4-4//

						end
						else begin
							data_count_Dec[11:8] <= data_count_Dec[11:8] + 4'h1;
						end
						//3-3-3-3-3//

					end
					else begin
						data_count_Dec[7:4] <= data_count_Dec[7:4] + 4'h1;
					end
					//2-2-2-2-2//

				end
				else begin
					data_count_Dec[3:0] <= data_count_Dec[3:0] + 4'h1;
				end
				//1-1-1-1-1//

			end
		end

		// count disable //
		if(RST == 1) begin
			data_count_Bin <= 0;
			data_count_Dec <= 16'h0000;
		end			
	end
endmodule
