`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company:				jc-21
// Engineer: 			T.Sakato
// 
// Create Date:		16:04:15 05/27/2010 
// Design Name:		7segment LED Driver
// Module Name:		seg7LED 
// Project Name:		softwear Design
// Target Devices:	xc3s100e-5vq100
// Tool versions:		ISE 8.2i
// Description:		VerilogHDL
//
// Dependencies:		None
//
// Revision:			1.0
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module seg7LED(Bit_In, Led_Data);
input	[3:0]Bit_In ;
output	[7:0]Led_Data ;

	function [7:0]dec ;
	input [3:0]in_data ;
		case (in_data)
			4'b0000:	dec = 8'b00111111 ;	// 0
			4'b0001:	dec = 8'b10000110 ;	// 1.
			4'b0010:	dec = 8'b01011011 ;	// 2
			4'b0011:	dec = 8'b11001111 ;	// 3.
			4'b0100:	dec = 8'b01100110 ;	// 4
			4'b0101:	dec = 8'b11101101 ;	// 5.
			4'b0110:	dec = 8'b01111101 ;	// 6
			4'b0111:	dec = 8'b10100111 ;	// 7.
			4'b1000:	dec = 8'b01111111 ;	// 8
			4'b1001:	dec = 8'b11100111 ;	// 9.
			4'b1010:	dec = 8'b01110111 ;	// A
			4'b1011:	dec = 8'b11111100 ;	// b.
			4'b1100:	dec = 8'b00111001 ;	// C
			4'b1101:	dec = 8'b11011110 ;	// d.
			4'b1110:	dec = 8'b01111001 ;	// E
			4'b1111:	dec = 8'b11110001 ;	// F.
		endcase
	endfunction

	assign Led_Data = ~dec(Bit_In) ;

endmodule
