`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company:				jc-21
// Engineer: 			T.Sakato
// 
// Create Date:		16:04:15 06/02/2010 
// Design Name:		7segment LED Decoder
// Module Name:		seg7LED2 
// Project Name:		softwear Design
// Target Devices:	xc3s100e-5vq100
// Tool versions:		ISE 8.2i
// Description:		VerilogHDL
//
// Dependencies:		None
//
// Revision:			1.0
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module seg7LED2(Bit_In, Led_Sel, Led_Data);
input		[3:0]Bit_In ;
output	[4:1]Led_Sel ;
output	[7:0]Led_Data ;

function [7:0]seg_data ;
	input bit3 ;
	input bit2 ;
	input bit1 ;
	input bit0 ;

	begin

	//seg_a
		seg_data[0] = ((!bit2 & !bit0) | (!bit3 & bit1) | (bit2 & bit1) | (bit3 & !bit0) | (!bit3 & bit2 & bit0) | (bit3 & !bit2 & !bit1)) ;

	//seg_bit
		seg_data[1] = ((!bit2 & !bit0) | (!bit3 & !bit2) | (!bit3 & !bit1 & !bit0) | (!bit3 & bit1 & bit0) | (bit3 & !bit1 & bit0)) ;

	//seg_c
		seg_data[2] = ((!bit3 & !bit1) | (!bit3 & bit0) | (!bit1 & bit0) | (!bit3 & bit2) | (bit3 & !bit2)) ;

	//seg_d
		seg_data[3] = ((bit2 & !bit1 & bit0) | (bit2 & bit1 & !bit0) | (!bit3 & !bit2 & !bit0) | (!bit2 & bit1 & bit0) | (bit3 & !bit1 & !bit0)) ;

	//seg_e
		seg_data[4] = ((!bit2 & !bit0) | (bit1 & !bit0) | (bit3 & bit2) | (bit3 & bit1)) ;

	//seg_f
		seg_data[5] = ((!bit1 & !bit0) | (!bit3 & bit2) | (bit3 & !bit2) | (bit2 & bit1)) ;

	//seg_g
		seg_data[6] = ((!bit2 & bit1) | (bit3 & bit0) | (bit1 & !bit0) | (bit3 & !bit2) | (!bit3 & bit2 & !bit1)) ;

	//seg_dp
		seg_data[7] = (bit0) ;

	end
endfunction

	assign Led_Sel = 4'b1110 ;
	assign Led_Data = ~seg_data(Bit_In[3],Bit_In[2],Bit_In[1],Bit_In[0] ) ;
//	assign Led_Data = ~seg_data(bit_In) ;

endmodule

